function CODISswap(a,b,c)
%CODISswap is a CODIS ancillary routine.
%This function is recalled when a swap of a locus is required
%
% Syntax: 	CODISswap(a,b,c)
%      
%     Inputs:
%           a - mother's locus swap (1 - yes, 0 - no)
%           b - child's locus swap (1 - yes, 0 - no)
%           c - alleged father's locus swap (1 - yes, 0 - no)
%     Outputs:
%           - the required locus/loci is/are swapped.
%
%      Example: 
%           CODISswap(1,0,0) - swap the mother's locus
%           CODISswap(1,1,0) - swap the mother's and the child's loci
%
%           Created by Giuseppe Cardillo
%           giuseppe.cardillo-edta@poste.it

global M C F I
if a
    %swap the mother's alleles
    M(I,:)=fliplr(M(I,:));
end
if b
    %swap the child's alleles
    C(I,:)=fliplr(C(I,:));
end
if c
    %swap the alleged father's alleles
    F(I,:)=fliplr(F(I,:));
end